
Redmine - Feature #3511

Ability to sort issues by grouped column

2009-06-18 21:10 - Anonymous

Status: Closed Start date: 2009-06-18

Priority: Low Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 2.2.0   

Resolution: Fixed   

Description

When grouping issues by a column, specifying a sort on that same column is ignored (should determine order of groups).  Sorting

within groups using other fields does work.

Related issues:

Has duplicate Redmine - Defect #4901: Cannot change Target version order for ... Closed 2010-02-23

Has duplicate Redmine - Defect #6131: Sort by Group By field does not work Closed 2010-08-13

Has duplicate Redmine - Feature #8252: Groups in a filter should be sortable Closed 2011-04-29

Associated revisions

Revision 10765 - 2012-10-29 19:32 - Jean-Philippe Lang

Ability to sort issues by grouped column (#3511).

History

#1 - 2009-07-08 05:22 - Vladimir Goryachev

- Assignee set to Jean-Philippe Lang

Yes, very ugly bug.

Please fix.

#2 - 2009-07-08 09:03 - Jean-Philippe Lang

- Assignee deleted (Jean-Philippe Lang)

- Priority changed from Normal to Low

Please do not assign tickets to anyone.

#3 - 2009-07-09 20:58 - Paul McMillan

+1

This issue also affects me.

#4 - 2010-01-24 22:07 - Kai Krakow

Please fix, still an issue in 0.9

#5 - 2010-06-07 19:26 - S Reid

Just upgraded to 0.9, and found this problem. Is this scheduled to be fixed ?

#6 - 2010-06-08 22:46 - Ondrej Hrebicek

Would love to see this fixed as well. Really makes the grouped view (when grouping by Version) impossible to use.

#7 - 2011-03-25 15:42 - Brian Lacy

I just want to confirm that I'm still experiencing the same problem. Our most crucial report Groups by Target Version, and the default order is

backwards! We have to scroll to the bottom of the report to see our most current Release. Very frustrating.
#8 - 2011-04-07 14:22 - S Reid

Still an issue as of 1.1.1. Annoying when using group by target version, and have several pages of issues.

#9 - 2011-04-26 18:02 - Etienne Massip

- Target version set to Candidate for next major release

#10 - 2011-04-30 17:40 - Cyber Sprocket

bump.

Group by target version is an issue on our larger projects.  Newer target versions, that we add later in the cycle, are sorting to the stop of the group-by

list.   Thus the current/active release always are pushed down near the bottom.

Sorting by target version should either sort alpha-numeric ascending (so v01.10 would show up before v01.20) or even better would be to make the

system sort by release date if target version is the grouping (much like road map & settings/versions).

#11 - 2011-08-24 09:54 - Etienne Massip

- Tracker changed from Defect to Feature

#12 - 2011-08-24 09:55 - Etienne Massip

- Subject changed from Can't sort issues by grouped column to Ability to sort issues by grouped column

#13 - 2011-09-26 14:09 - Stefan Lindner

We too need a fix for this. Or, as it is a feature from now, we need this feature.

#14 - 2011-10-12 11:08 - Hans Jakobsen

+1

This is an important feature, so you can view the full Issue list like a roadmap. Please give it high priority so it can be included soon.

#15 - 2011-11-02 16:29 - Alain V.

+1

Quite important I think to have a nice view.

#16 - 2011-11-03 10:01 - Toggi Muppet

+ 1

Annoying when using issues with customer that the highest version comes on top.

#17 - 2011-12-25 23:22 - Adam Sneller

+ 1

The nice thing about grouping issues by version is that the unassigned issues form a product backlog.  It would be helpful if these groupings could be

sorted so that the current sprint/version is first on the list.

#18 - 2012-02-22 08:58 - Stéphane Thomas

+1

In the meantime, I've added the following patch in a new file config/initializers/versions.rb:

require 'app/models/query'

class Query < ActiveRecord::Base

  after_initialize :reset_versions_order

  # Updates the list of available columns to specify ascending as order for versions

  def reset_versions_order

    @@available_columns[10] = QueryColumn.new(:fixed_version, :sortable => ["#{Version.table_name}.effective_d

ate", "#{Version.table_name}.name"], :default_order => 'asc', :groupable => true)

  end

end

 But maybe you can think of a better way to update this list of columns (those are my very first lines of code in RoR)?

#19 - 2012-04-20 20:29 - Anonymous

+1
#20 - 2012-04-30 18:41 - Nicola Bernardini

+1

I tried the patch by Stèphane but it does not work for me... Or at least I don't know how to make it work...

#21 - 2012-05-07 18:39 - Simeon Fitch

+1

Major efficiency impediment. Anyone have a temporary work around?

#22 - 2012-05-09 10:39 - Stéphane Thomas

I've just updated to Redmine 1.4.1 and indeed my patch did not work any more. Here is a new one:

require 'app/models/query'

class Query < ActiveRecord::Base

  # Updates the list of available columns to specify ascending as order for versions

  def after_initialize

    @@available_columns[10] = QueryColumn.new(:fixed_version, :sortable => ["#{Version.table_name}.effective_d

ate", "#{Version.table_name}.name"], :default_order => 'asc', :groupable => true)

  end

end

#23 - 2012-05-10 16:02 - Stéphane Thomas

- File redmine_issue_versions_order.zip added

Since I've encountered some weird errors with this new patch when browsing issues, I did repackage it as a plugin. Enjoy!

#24 - 2012-05-24 17:55 - Rick Hunnicutt

Great, thank you! Just unzip it in the plugin directory and restart redmine?

#25 - 2012-05-24 18:01 - Stéphane Thomas

That's it, Rick!

#26 - 2012-05-24 18:45 - Rick Hunnicutt

So, just to be clear, this plugin only changes the sort order of the Versions from descending to ascending. It doesn't add the ability to (re)sort the

groups in any way.

#27 - 2012-06-26 05:48 - Anthony S

In the description of this issue there is an attached file "redmine_issue_versions_order.zip"

How do I apply the patch in it? And does it work in 2.0?

#28 - 2012-08-08 23:46 - Jean-Philippe Lang

- Target version changed from Candidate for next major release to 2.2.0

#29 - 2012-09-18 08:14 - Jonathan Vargas

+1. Please consider Stéphane patch but apply it to a more general use case when sorting group-by's

#30 - 2012-09-18 18:59 - Jean-Philippe Lang

The sort order when grouping by version is fixed in 2.1.0, it's now ascending.

#31 - 2012-10-29 15:10 - Daniel Felix

Jean-Philippe Lang wrote:

The sort order when grouping by version is fixed in 2.1.0, it's now ascending.

 But currently there is no way to define (by click) a descending order on some grouped field, or?

#32 - 2012-10-29 19:33 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang
- Resolution set to Fixed

Implemented in r10765. You can sort issues by the grouped column in order to display groups in reverse order.

#33 - 2012-10-29 20:37 - Jonathan Vargas

Thanks!

#34 - 2012-10-30 06:13 - Daniel Felix

Thanks. Just tested! Works for me. :-)

#35 - 2013-07-10 10:51 - Radhakrishna M

Stéphane Thomas wrote:

+1

In the meantime, I've added the following patch in a new file config/initializers/versions.rb:

[...]

But maybe you can think of a better way to update this list of columns (those are my very first lines of code in RoR)?

 Can we sort the Reports in user name order likewise? how to ?

Files

redmine_issue_versions_order.zip 1.34 KB 2012-05-10 Stéphane Thomas
